#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "buf.h"

int main(int argc, char *argv[])
{
	printf("======= line buffer test =======\n\n");

	void line(void *data, char *line, int len)
	{
		printf("LINE: %d bytes: '%s'\n", len, line);
	}

	buf_line_t *lb = buf_line_new(NULL, line);

	char *test[] = {
		"p1",
		"part2",
		"p3",
		"part4\n",
		"Alpha\n",
		"Beta\n\nGamma\n",
		"Delta\nEpsilon\nZeta",
		"\nEta\nTheta\nIota, ",
		"Kappa\nLam",
		"",
		"bda\nMu"
	};

	int i;
	for(i=0; i<sizeof(test)/sizeof(test[0]); i++) {
		printf("Write: %zd bytes: '%s'\n", strlen(test[i]), test[i]);
		buf_line_write(lb, test[i], strlen(test[i]));
	}

	buf_line_free(lb);

	printf("\n\n======= fifo test =======\n\n");

	char *ftest[] = {
	/*   123456781234567812345678 */
		"Nu",
		"Xi",
		"Omicron Pi",
		"Rho Sigma Tau Upsilon",
		"Phi  Chi",
		"Psi Omega Digamma",
		"Qoppa",
		"Sa",
		"n Sampi Stigma Heta  Sho",
		"Zaxxon"
	};

	buf_fifo_t *bf = buf_fifo_new(8);

	for(i=0; i<sizeof(ftest)/sizeof(ftest[0]); i++) {
		printf("Write: %zd bytes: '%s'\n", strlen(ftest[i]), ftest[i]);
		buf_fifo_write(bf, ftest[i], strlen(ftest[i]));

		char *pk;
		int b = buf_fifo_getpacket(bf, &pk);
		if(b > 0) {
			printf("Available packet: %d bytes\n", b);

			int adv = i&1 ? b : (b/2+1);
			printf("Advance: %d bytes: '", adv);
			fwrite(pk, adv, 1, stdout);
			printf("'\n");

			buf_fifo_advance(bf, adv);

			b = buf_fifo_getpacket(bf, &pk);
		}
	}

	char *pk;
	int b = buf_fifo_getpacket(bf, &pk);
	while(b > 0) {
		printf("Available packet: %d bytes\n", b);

		int adv = i&2 ? b : (b/2+1);
		printf("Advance: %d bytes: '", adv);
		fwrite(pk, adv, 1, stdout);
		printf("'\n");

		buf_fifo_advance(bf, adv);

		b = buf_fifo_getpacket(bf, &pk);

		i ++;
	}

	buf_fifo_free(bf);

	return 0;
}
